import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import descriptor.*;

public class Main {
    public static void main(String[] args){
        Main main = new Main();
        List list = main.createAttributeDescriptors();
        Iterator it = list.iterator();
        while(it.hasNext()){
            System.out.println("class name is : " + it.next().getClass().getName());
        }
    }

    public List createAttributeDescriptors(){
        List result = new ArrayList();

        result.add(forInteger("remoteId", getClass()));
        result.add(forDate("createDate", getClass()));
        result.add(forDate("lastChangeDate", getClass()));
        result.add(forReference("createdBy", getClass()));
        result.add(forReference("lastChangedBy", getClass()));
        result.add(forInteger("optimisticLockVersion", getClass()));

        return result;
    }
    public static DefaultDescriptor forInteger(String column, Class cls){
        return new DefaultDescriptor(column,cls,Integer.TYPE);
    }
    public static DefaultDescriptor forDate(String column, Class cls){
        return new DefaultDescriptor(column,cls,Date.class);
    }
    public static ReferenceDescriptor forReference(String column, Class cls){
        return new ReferenceDescriptor(column, cls, User.class, RemoteUser.class);
    }
 
}

class Integer {
    public static int TYPE = 0;
}

class Date {
}

class User {
}

class RemoteUser {
}

